function GetXmlHttpObject() {
	var xmlHttp = null;
	try { xmlHttp=new XMLHttpRequest(); }
	catch (e) {
		try { 
			xmlHttp=new ActiveXObject("Msxml2.XMLHTTP");
		} catch (e) {
			xmlHttp=new ActiveXObject("Microsoft.XMLHTTP");
		}
	}
	return xmlHttp;
}

function isEqualSrc(src, icon_src){
	if (src==icon_src) 
		return true;
	if (src.substring(src.length-icon_src.length)==icon_src)
		return true;
	icon_src  = icon_src.substring(3);
	if (src.substring(src.length-icon_src.length)==icon_src)
		return true;
	return false;
	
}

function processBranch(branch_id, tree_name, response_url) {
	var div_id  = tree_name + "_branch_" + branch_id;
	var icon_name = tree_name + "_branch_icon_" + branch_id;
	var icons     = document.getElementsByName(icon_name);
	
	if ( isEqualSrc(icons[0].src, showIcon) ) {
		xmlHttp = GetXmlHttpObject();
		if (xmlHttp == null) {
			alert ("Your browser does not support AJAX!");
			return;
		} 
		xmlHttp.onreadystatechange = function() { loadedBranch(branch_id, tree_name); };  
		xmlHttp.open("GET", response_url+'&branch_id='+branch_id, true);
		xmlHttp.setRequestHeader('Content-Type', 'application/ajax+html');
		for(j=0; j<icons.length; j++)
			icons[j].src = loadIcon;
		xmlHttp.send(null);			
	} else if ( isEqualSrc(icons[0].src, hideIcon) ) {
		for(j=0; j<icons.length; j++)
			icons[j].src = showIcon;
		document.getElementById(div_id).style.display = 'none';
	} else {
		document.getElementById(div_id).innerHTML = 'Processing...';
		document.getElementById(div_id).style.display = 'block';
	}
}	

function loadedBranch(branch_id, tree_name) {
	var div_id  = tree_name + "_branch_" + branch_id;
	var icon_name = tree_name + "_branch_icon_" + branch_id;
	var icons     = document.getElementsByName(icon_name);
	
	if (xmlHttp.readyState == 4) {		
		var responseText = xmlHttp.responseText;
		document.getElementById(div_id).innerHTML = responseText;
		document.getElementById(div_id).style.display = 'block';
		for(j=0; j<icons.length; j++)
			icons[j].src = hideIcon;
		markSelectedLeafes(tree_name);
	}
}

function processLeaf(id, text, tree_name) {
	if(document.getElementById(tree_name + '_action_object_id')) {
		var icon_name = tree_name + "_leaf_icon_" + id;
		var icons = document.getElementsByName(icon_name);
		var action_object_id = document.getElementById(tree_name + '_action_object_id').value;
		var action_object_type = document.getElementById(tree_name + '_action_object_type').value;
		if (action_object_type = 'ul') {
			var child_id =  action_object_id + '_' + id;
			var list = document.getElementById(action_object_id);
				
			if ( isEqualSrc(icons[0].src, addIcon) ) {
				for(var j=0; j<icons.length; j++)
					icons[j].src = removeIcon;
				var child = document.createElement('li');
				child.id  = child_id;
				child.className = "tree_leaf";
				child.innerHTML = addLeafFormat(id, text, tree_name, action_object_id);
				list.appendChild(child);				
			} else {		
				for(var j=0; j<icons.length; j++)
					icons[j].src = addIcon;				
				if (list.hasChildNodes()) {					
					list.removeChild(document.getElementById(child_id));					
				}
			}
		}  else if (action_object_type = 'select') {
			if ( isEqualSrc(icons[0].src, addIcon) ) {
				for(j=0; j<icons.length; j++)
					icons[j].src = removeIcon;
				document.record[action_object_id].options[document.record[action_object_id].length] = new Option(text, id);		
			} else {		
				for(var j=0; j<icons.length; j++)
					icons[j].src = addIcon;
				for (var i=0; i<document.record[action_object_id].length; i++){
					if (document.record[action_object_id].options[i].value==id) {
						document.record[action_object_id].options[i] = null;
						break;
					}
				}		
			}			
		}
	}
}

function markSelectedLeafes(tree_name) {
	if(document.getElementById(tree_name + '_action_object_id')) {
		var action_object_id = document.getElementById(tree_name + '_action_object_id').value;
		var action_object_type = document.getElementById(tree_name + '_action_object_type').value;
		
		if (action_object_type = 'ul') {
			var list = document.getElementById(action_object_id);			
			if (list.hasChildNodes()) {
				var children = list.childNodes; 
				for (var i=0; i<children.length; i++){
					if (children[i].id) {
						var id = children[i].id.substring(action_object_id.length+1);
						var icon_name = tree_name + "_leaf_icon_" + id;
						var icons = document.getElementsByName(icon_name);
						if (icons) {							
							for(var j=0; j<icons.length; j++)
								icons[j].src = removeIcon;
						}						
					}					
				}				
			}		
		} else if (action_object_type = 'select') {
			var select = document.record[action_object_id];
			for (var i=0; i<select.length; i++){
				var icon_name = tree_name + "_leaf_icon_" + select.options[i].value;
				var icons = document.getElementsByName(icon_name);
				if (icons) {							
					for(var j=0; j<icons.length; j++)
						icons[j].src = removeIcon;
				}
			}
		}
	}
}

// ul list special functions
var selectedListItem = new Array();
var ctrlPressed  = 0;
var altPressed   = 0;
var shiftPressed = 0;
	
function mouseDown(e) {
	removeUserSelection();
	ctrlPressed  = 0;
	altPressed   = 0;
	shiftPressed = 0;
	if (parseInt(navigator.appVersion)>3) {

		var evt = navigator.appName=="Netscape" ? e:event;

		if (navigator.appName=="Netscape" && parseInt(navigator.appVersion)==4) {
			// NETSCAPE 4 CODE
			var mString =(e.modifiers+32).toString(2).substring(3,6);
			shiftPressed=(mString.charAt(0)=="1");
			ctrlPressed =(mString.charAt(1)=="1");
			altPressed  =(mString.charAt(2)=="1");
		} else {
			// NEWER BROWSERS [CROSS-PLATFORM]
			shiftPressed=evt.shiftKey;
			altPressed  =evt.altKey;
			ctrlPressed =evt.ctrlKey;
		}
	}
	return false;
}

function removeUserSelection() {
	var userSelection;
	if (window.getSelection) {
		userSelection = window.getSelection();
		userSelection.removeAllRanges();
	} else if (document.selection) {
		userSelection = document.selection.createRange();
		document.selection.empty();
	}
}


function selectListItem(id, tree_name, action_object_id) {
	removeUserSelection();
	var current_index = -1;
	var child_id = action_object_id + '_' + id;
	var child    = document.getElementById(child_id);
	var child_node = child.childNodes[0];
	if (ctrlPressed) {		
		if (selectedListItem) {
			for(var j=0; j<selectedListItem.length; j++) {
				var prev_child_id = selectedListItem[j];
				if (prev_child_id) {
					if (prev_child_id == child_id) {
						current_index = j;
					}
				}
			}
			if (current_index == -1) {
				child_node.className = "selected";
				selectedListItem[selectedListItem.length] = child_id;
			} else {
				child_node.className = "";
				selectedListItem[current_index] = false;
			}
		}		
	} else {
		// simple select one by one
		if (selectedListItem) {
			for(var j=0; j<selectedListItem.length; j++) {
				var prev_child_id = selectedListItem[j];
				if (prev_child_id) {
					var prev_child = document.getElementById(selectedListItem[j]);
					if (prev_child) {
						prev_child.childNodes[0].className = "";
						if (prev_child_id == child_id) {
							current_index = j;
						}
					}
				}
			}
		}
		if (current_index == -1 ) {
			child_node.className = "selected";
			selectedListItem = new Array(child_id);
		} else {
			child_node.className = "";
			selectedListItem = new Array();
		}
	}
	return false;
}

function removeSelectedListItem(tree_name, action_object_id) {
	for(var j=0; j<selectedListItem.length; j++) {
		var child_id = selectedListItem[j];
			if (child_id) {
			var tmp = child_id.split('_');
			if (tmp) {
				var id = tmp[tmp.length-1];
				removeListItem(id, tree_name, action_object_id);
			}
		}		
	}
	selectedListItem = new Array();
	return false;
}

function removeListItem(id, tree_name, action_object_id) {
	var icon_name = tree_name + "_leaf_icon_" + id;
	var icons = document.getElementsByName(icon_name);
	var child_id =  action_object_id + '_' + id;
	var list = document.getElementById(action_object_id);
	for(var j=0; j<icons.length; j++)
		icons[j].src = addIcon;				
	if (list.hasChildNodes()) {					
		list.removeChild(document.getElementById(child_id));
	}
	return false;
}

function moveSelectedListItem(direction, tree_name, action_object_id) {
	for(var j=0; j<selectedListItem.length; j++) {
		var child_id = selectedListItem[j];
		if (child_id) {
			var tmp = child_id.split('_');
			if (tmp) {
				var id = tmp[tmp.length-1];
				moveListItem(id, direction, tree_name, action_object_id);
			}
		}		
	}
	return false;
	
}

function moveListItem(id, direction, tree_name, action_object_id) {
	var icon_name = tree_name + "_leaf_icon_" + id;
	var icons = document.getElementsByName(icon_name);
	var child_id =  action_object_id + '_' + id;
	var list = document.getElementById(action_object_id);
	
	var c1, c2;
	if (list.hasChildNodes()) {
		var children    = list.childNodes;
    	var numchildren = children.length;    	
	    for(var i=0; i < numchildren; i++) {    	
	    	if(children[i].id) {
		    	if (children[i].id == child_id) {
		        	c1 = children[i];
		        	if(direction>0 && i<numchildren-1) {		        		
		        		c2 = children[i+1];
		        	} else if(direction<0 && i>0) {
		        		c2 = children[i-1];		        	
		        	}
		        	if(c2 && c2.id) {		        		
		        		var c3 = document.createElement("li");
		        		c3.id = c1.id;		        		
		        		c3.innerHTML = c1.innerHTML;
		        		c3.className = "tree_leaf";
		        		var c4 = document.createElement("li");
		        		c4.id = c2.id;
		        		c4.className = "tree_leaf";
		        		c4.innerHTML = c2.innerHTML;
		        		list.appendChild(c3);
		        		list.appendChild(c4);
		        		list.replaceChild(c4, c1);
		        		list.replaceChild(c3, c2);		        		
		        	}
		        	break;		    	
		    	}
	    	}
	    }  			
	}
	return false;
}

function addListItems(field_name, tree_name, action_object_id) {
	var source = document.getElementsByName(field_name)[0];
	var list = document.getElementById(action_object_id);
	var totalOptions = source.length;
	for(var i = totalOptions - 1; i >= 0; i--) {
		if (source.options[i].selected == true) {
			var id    = source.options[i].value;
			var text  = source.options[i].text;
			var child_id  = action_object_id + '_' + id;
			if (!document.getElementById(child_id)){
				var child = document.createElement('li');
				child.id  =  child_id;
				child.className = "tree_leaf";
				child.innerHTML = addLeafFormat(id, text, tree_name, action_object_id);
				list.appendChild(child);
			}
			
		}
	}
	return false;
}

function saveListItems(field_name, tree_name, action_object_id) {
	var target = document.getElementsByName(field_name)[0];
	var list = document.getElementById(action_object_id);
	if (list.hasChildNodes()) {
		var children    = list.childNodes;
		var numchildren = children.length;   
		target.value = "";	
		for(var i = 0; i <numchildren; i++) {
			if (children[i].id) {
				var id = children[i].id.substring(action_object_id.length+1);
				if(target.value.length > 0) target.value += ",";
				target.value += id;			
			}
		}   
	} else {
		target.value = "";
	}
	return false;
}